'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactStyles = require('@patternfly/react-styles');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactEmotion = require('react-emotion');

var _reactEmotion2 = _interopRequireDefault(_reactEmotion);

var _styledSystem = require('styled-system');

var _StyledBox = require('./StyledBox');

var _StyledBox2 = _interopRequireDefault(_StyledBox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var StyledFlexBase = (0, _reactEmotion2.default)(_StyledBox.StyledBoxBase)({
  display: 'flex'
},
// flex parent props
_styledSystem.flexWrap, _styledSystem.flexDirection, _styledSystem.alignItems, _styledSystem.alignContent, _styledSystem.justifyContent);

/**
 * StyledFlex inherits all the props from the StyledBox component.
 */
var StyledFlex = function StyledFlex(_ref) {
  var className = _ref.className,
      children = _ref.children,
      component = _ref.component,
      props = _objectWithoutProperties(_ref, ['className', 'children', 'component']);

  var StyledFlexBaseWithComponent = StyledFlexBase.withComponent(component);
  return _react2.default.createElement(
    StyledFlexBaseWithComponent,
    _extends({}, props, { className: (0, _reactStyles.css)(className) }),
    children
  );
};

StyledFlex.propTypes = _extends({}, _StyledBox2.default.propTypes, {

  /** flex-wrap */
  flexWrap: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string, _propTypes2.default.array]),
  /** flex-direction */
  flexDirection: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string, _propTypes2.default.array]),
  /** align-items */
  alignItems: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string, _propTypes2.default.array]),
  /** align-content */
  alignContent: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string, _propTypes2.default.array]),
  /** justify-content */
  justifyContent: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string, _propTypes2.default.array])
});

StyledFlex.defaultProps = _extends({}, _StyledBox2.default.defaultProps, {

  flexWrap: null,
  flexDirection: null,
  alignItems: null,
  alignContent: null,
  justifyContent: null
});

exports.default = StyledFlex;